//---------------------------------------------------------------------------

#ifndef MyConvertWAVH
#define MyConvertWAVH
//---------------------------------------------------------------------------
#include <windows.h>
#include <mmsystem.h>
#include <mmreg.h>
#include <msacm.h>
#include <math.h>

#define BLOCK_SAMPLES		1024
#define FIR_BLOCK_SIZE		256
#define FIR_KERNEL_SIZE		257
#define COPY_BLOCK_SIZE		0x4000

const int FFT_SIZE = 1 << (int)ceil(log(FIR_BLOCK_SIZE + FIR_KERNEL_SIZE - 1) / log(2));

void SamplesToFloat(float *, LPVOID, LPWAVEFORMATEX, int, int);
void FloatToSamples(float *, LPVOID, LPWAVEFORMATEX, int, int);
BOOL MyConvertWAV(TCHAR *, TCHAR *, LPWAVEFORMATEX DestFmt, BOOL UseFilter, BOOL Normalize);
BOOL ConvertData(HANDLE, HANDLE, LPWAVEFORMATEX, LPWAVEFORMATEX, DWORD, BOOL, BOOL);
BOOL CopyFileBlock(HANDLE, HANDLE, DWORD, DWORD);
BOOL AnalyzeData(HANDLE, DWORD, bool, int &);
void NormalizeData(LPBYTE, DWORD, LPWAVEFORMATEX, int);
void Resample(float **, LPWAVEFORMATEX, float **, LPWAVEFORMATEX, int, int);
void ResampleChannel(float *, float *, int, int);
void InitFilter(float *, float *, int, float);
void Filter(float *, float *, float **, float **, int, int);
void ForwardFFT(int, float *, float *);
void InverseFFT(int, float *, float *);
void FFT(int, float *, float *);
int log2(int);

struct WAVSection {
	char Name[4];
	DWORD Size;
};

struct WAVHeader {
	WAVSection RIFF;
	char WAVE[4];
	WAVSection fmt;
};

bool GetFileFormat(HANDLE hSrcFile, WAVHeader *whdr, LPWAVEFORMATEX wfx, DWORD &DataSize);

#endif
