//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TConvertDlg.h"

typedef struct _browseinfoA {
    HWND        hwndOwner;
    LPVOID      pidlRoot;
    LPSTR        pszDisplayName;
    LPCSTR       lpszTitle;
    UINT         ulFlags;
    LPVOID      lpfn;
    LPARAM       lParam;
    int          iImage;
} BROWSEINFO;

SHSTDAPI_(LPVOID) SHBrowseForFolderA(BROWSEINFO *);
SHSTDAPI_(BOOL) SHGetPathFromIDListA(LPVOID, LPSTR);
SHSTDAPI_(int) SHCreateDirectoryExA(HWND, LPCSTR, SECURITY_ATTRIBUTES *);

char PathBuf[MAX_PATH];

//---------------------------------------------------------------------
#pragma resource "*.dfm"
TConvertDlg *ConvertDlg;
//---------------------------------------------------------------------
__fastcall TConvertDlg::TConvertDlg(TComponent* AOwner)
	: TForm(AOwner)
{
    ZeroMemory(PathBuf, sizeof(PathBuf));
}
//---------------------------------------------------------------------
int CALLBACK BrowseCallbackProc(HWND hWnd, UINT uMsg,
    LPARAM lParam, LPARAM lpData)
{
    if (uMsg == 1)
        SendMessage(hWnd, WM_USER + 102, TRUE, (LPARAM)PathBuf);

    return 0;
}
//---------------------------------------------------------------------
void __fastcall TConvertDlg::BrowseBtnClick(TObject *Sender)
{
    BROWSEINFO bi;
    ZeroMemory(&bi, sizeof(bi));
    bi.hwndOwner = Handle;
    bi.lpfn = BrowseCallbackProc;
    bi.lpszTitle = "     ";
    bi.ulFlags = 0x0010 | 0x0040 | 0x0001;
    LPVOID Res = SHBrowseForFolderA(&bi);
    if (!Res) return;
    SHGetPathFromIDListA(Res, PathBuf);
    SaveFolder->Text = PathBuf;
}
//---------------------------------------------------------------------------
void __fastcall TConvertDlg::OKBtnClick(TObject *Sender)
{
    if (RadioButton1->Checked)
    {
        if (SaveFolder->Text == "")
        {
            Application->MessageBox("     ",
                " ", MB_OK | MB_ICONEXCLAMATION);
            return;
        }
        switch (SHCreateDirectoryExA(NULL, SaveFolder->Text.c_str(), NULL))
        {
            case ERROR_ALREADY_EXISTS:
            case ERROR_FILE_EXISTS:
            case ERROR_SUCCESS: break;
            default:
                Application->MessageBox("   ",
                    "", MB_OK | MB_ICONSTOP);
                return;
        }
    }
    if (RadioButton2->Checked)
    {
        if (SrcFile->Text == "")
        {
            Application->MessageBox("   ",
                " ", MB_OK | MB_ICONWARNING);
            return;
        }
        if (DestFile->Text == "")
        {
            Application->MessageBox("   ",
                " ", MB_OK | MB_ICONWARNING);
            return;
        }
    }
    Format.wFormatTag = WAVE_FORMAT_PCM;
    try
    {
        Format.nSamplesPerSec = SampleRateList->Text.ToInt();
        VoxFreq = VOXSampleRateList->Text.ToInt();
        if (Format.nSamplesPerSec < 4000 ||
            Format.nSamplesPerSec > 192000) throw Exception("");
        if (VoxFreq < 4000 || VoxFreq > 192000) throw Exception("");
    }
    catch (Exception &e)
    {
        Application->MessageBox("       4000  192000",
            "", MB_OK | MB_ICONEXCLAMATION);
        return;
    }
    Format.wBitsPerSample = (BitsPerSample->ItemIndex + 1) << 3;
    Format.nChannels = Channels->ItemIndex + 1;
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TConvertDlg::RadioButton1Click(TObject *Sender)
{
    SaveFolder->Enabled = RadioButton1->Checked;
    BrowseBtn->Enabled = RadioButton1->Checked;
    SrcFile->Enabled = RadioButton2->Checked;
    DestFile->Enabled = RadioButton2->Checked;
    BrowseBtn1->Enabled = RadioButton2->Checked;
    BrowseBtn2->Enabled = RadioButton2->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TConvertDlg::RadioButton2Click(TObject *Sender)
{
    RadioButton1Click(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TConvertDlg::FormatsClick(TObject *Sender)
{
    BitsPerSample->Enabled = !Formats->ItemIndex;
    Channels->Enabled = !Formats->ItemIndex;
    if (RadioButton2->Checked && DestFile->Text != "")
    {
        char szFileName[MAX_PATH];
        lstrcpy(szFileName, DestFile->Text.c_str());
        char *p = strchr(szFileName, '.');
        if (p) *p = 0;
        if (!Formats->ItemIndex)
            lstrcat(szFileName, ".wav");
        else
            lstrcat(szFileName, ".vox");
        DestFile->Text = szFileName;
    }
}
//---------------------------------------------------------------------------
void __fastcall TConvertDlg::BrowseBtn1Click(TObject *Sender)
{
    if (!OpenDialog->Execute()) return;
    SrcFile->Text = OpenDialog->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TConvertDlg::BrowseBtn2Click(TObject *Sender)
{
    if (!SaveDialog->Execute()) return;
    DestFile->Text = SaveDialog->FileName;
}
//---------------------------------------------------------------------------

